'From VisualWorks®, Pre-Release 7.6 (jan08.1) of Freitag, 11. Januar 2008 on Samstag, 9. Februar 2008 at 12:40:43'!
"Package SeasideEnhancements(1.0,holgi)="!


Object subclass: #AsyncUpdater
	instanceVariableNames: 'id renderBlock '
	classVariableNames: ''
	poolDictionaries: ''
	category: ''!

AsyncUpdater class
	instanceVariableNames: ''!

AsyncUpdater subclass: #MootoolsAsyncUpdater
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: ''!

MootoolsAsyncUpdater class
	instanceVariableNames: ''!

WAComponent subclass: #ExampleTreeComponent
	instanceVariableNames: 'exampleClass children parentComponent isExpanded subscriptionRegistry '
	classVariableNames: ''
	poolDictionaries: ''
	category: ''!

ExampleTreeComponent class
	instanceVariableNames: ''!

WACompound subclass: #AsyncUpdatedArea
	instanceVariableNames: 'updater '
	classVariableNames: ''
	poolDictionaries: ''
	category: ''!

AsyncUpdatedArea class
	instanceVariableNames: ''!

Announcement subclass: #ExampleClassVisitAnnouncement
	instanceVariableNames: 'exampleClass '
	classVariableNames: ''
	poolDictionaries: ''
	category: ''!

ExampleClassVisitAnnouncement class
	instanceVariableNames: ''!

WAComponent subclass: #ExampleRootComponent
	instanceVariableNames: 'treeComponent rootClass '
	classVariableNames: ''
	poolDictionaries: ''
	category: ''!

ExampleRootComponent class
	instanceVariableNames: ''!












!ExampleClassVisitAnnouncement class methodsFor: 'instance creation' stamp: ' 9/2/08 12:40'!

exampleClass: aExampleClass
	
	^(self new)
		exampleClass: aExampleClass;
		yourself! !


!ExampleClassVisitAnnouncement methodsFor: 'accessing' stamp: ' 9/2/08 12:40'!

exampleClass: aExampleClass
	
	exampleClass _ aExampleClass!

exampleClass
	
	^exampleClass! !


!ExampleRootComponent class methodsFor: 'class initialization' stamp: ' 9/2/08 12:40'!

initialize
	"self unregisterApplicationFrom: WADispatcher default."
	
	| app |
	app _ self registerAsApplication: 'SeasideEnhancements'.
	app addLibrary: MootoolsLibrary! !

!ExampleRootComponent class methodsFor: 'testing' stamp: ' 9/2/08 12:40'!

canBeRoot
	
	^true! !

!ExampleRootComponent class methodsFor: 'accessing' stamp: ' 9/2/08 12:40'!

description
	
	^'Seaside enhancements (announcements and AJAX) example '! !


!ExampleRootComponent methodsFor: 'accessing' stamp: ' 9/2/08 12:40'!

treeComponent
	
	treeComponent isNil
		ifTrue:
			[treeComponent _ ExampleTreeComponent onClass: self rootClass.
			treeComponent
				when: ExampleClassVisitAnnouncement
				do: [:visit | self visit: visit exampleClass]].
	^treeComponent!

rootClass: aRootClass
	
	rootClass _ aRootClass!

children
	
	^Array with: self treeComponent!

rootClass
	
	^rootClass ifNil: [rootClass _ WATagBrush]!

visit: aClass
	
	self
		call:
			((self class new)
				rootClass: aClass;
				yourself)! !

!ExampleRootComponent methodsFor: 'rendering' stamp: ' 9/2/08 12:40'!

renderContentOn: canvas
	
	canvas unorderedList: [canvas render: self treeComponent]! !


!AsyncUpdatedArea class methodsFor: 'instance creation' stamp: ' 9/2/08 12:40'!

updater: aUpdater
	
	^(self new)
		updater: aUpdater;
		yourself! !


!AsyncUpdatedArea methodsFor: 'public' stamp: ' 9/2/08 12:40'!

with: anObject
	
	updater isNil
		ifTrue:
			[updater _ AsyncUpdater
				id: parent id
				renderWith: [:update :updateCanvas | updateCanvas render: anObject]].
	super with: anObject! !

!AsyncUpdatedArea methodsFor: 'accessing' stamp: ' 9/2/08 12:40'!

updater: aUpdater
	
	updater _ aUpdater!

updater
	
	^updater!

asyncUpdater
	
	^updater! !


!AsyncUpdater class methodsFor: 'instance creation' stamp: ' 9/2/08 12:40'!

id: aId renderWith: aUpdateBlock
	
	^(self new)
		id: aId;
		renderBlock: aUpdateBlock;
		yourself! !


!AsyncUpdater methodsFor: 'accessing' stamp: ' 9/2/08 12:40'!

id
	
	^id!

onEventHandlerFor: canvas callback: callbackBlock
	
	self subclassResponsibility!

renderBlock
	
	^renderBlock!

renderBlock: aUpdateBlock
	
	renderBlock _ aUpdateBlock!

id: aId
	
	id _ aId! !

!AsyncUpdater methodsFor: 'rendering' stamp: ' 9/2/08 12:40'!

renderOn: canvas
	
	self renderBlock cull: self cull: canvas! !


!MootoolsAsyncUpdater methodsFor: 'accessing' stamp: ' 9/2/08 12:40'!

onEventHandlerFor: canvas callback: callbackBlock
	
	^((canvas mooRequestHtml)
		update: self id;
		callback:
				[:updateCanvas | 
					| syncBrush |
					syncBrush _ updateCanvas brush: (AsyncUpdatedArea updater: self).
					syncBrush updater: self.
					syncBrush
						with:
							[callbackBlock cull: updateCanvas.
							self renderBlock cull: self cull: updateCanvas]]) send! !


!ExampleTreeComponent class methodsFor: 'instance creation' stamp: ' 9/2/08 12:40'!

onClass: aExampleClass
	
	^(super new)
		exampleClass: aExampleClass;
		buildComponents;
		yourself! !


!ExampleTreeComponent methodsFor: 'private' stamp: ' 9/2/08 12:40'!

buildComponents
	
	| sortedClasses |
	sortedClasses _ self exampleClass subclasses
		asSortedCollection: [:cl1 :cl2 | cl1 displayString <= cl2 displayString].
	children _ sortedClasses
		collect:
			[:cl | 
			| childComponent |
			childComponent _ self class onClass: cl.
			childComponent parentComponent: self.
			childComponent]!

parentComponent
	
	^parentComponent!

parentComponent: aParentComponent
	
	parentComponent _ aParentComponent! !

!ExampleTreeComponent methodsFor: 'accessing' stamp: ' 9/2/08 12:40'!

exampleClass: aExampleClass
	
	exampleClass _ aExampleClass!

isExpanded
	
	^isExpanded ifNil: [isExpanded _ false]!

isExpanded: aBoolean
	
	isExpanded _ aBoolean!

states
	
	^Array with: self isExpanded!

exampleClass
	
	^exampleClass!

children
	
	^children! !

!ExampleTreeComponent methodsFor: 'rendering' stamp: ' 9/2/08 12:40'!

renderToggleOn: canvas
	
	| text |
	self children notEmpty
		ifTrue:
			[text _ self isExpanded
				ifTrue: ['-']
				ifFalse: ['+'].
			(canvas anchor)
				asyncCallback: [self isExpanded: self isExpanded not];
				with: [canvas text: text]]!

renderClassOn: canvas
	
	canvas text: self exampleClass displayString.
	canvas text: ' ('.
	(canvas anchor)
		callback: [self announceVisit];
		with: [canvas text: 'Focus'].
	canvas text: ')'!

renderContentOn: canvas
	
	(canvas listItem)
		id: canvas nextId;
		asyncRenderWith:
				[:updateCanvas | 
					self renderToggleOn: updateCanvas.
					updateCanvas space.
					self renderClassOn: updateCanvas.
					(self isExpanded and: [self children notEmpty])
						ifTrue:
							[updateCanvas
								unorderedList:
									[self children do: [:comp | updateCanvas render: comp]]]]! !

!ExampleTreeComponent methodsFor: 'announcements' stamp: ' 9/2/08 12:40'!

announceVisit
	
	self
		announceOrDelegate:
			(ExampleClassVisitAnnouncement exampleClass: self exampleClass)!

subscriptionRegistryOrNil
	
	^subscriptionRegistry!

subscriptionRegistry: aSubscriptionRegistry
	
	subscriptionRegistry _ aSubscriptionRegistry! !


!WAComponent methodsFor: 'announcements' stamp: ' 9/2/08 12:40'!

delegate: anAnnouncementOrClass
	
	^self parentComponent
		ifNotNil: [:pc | pc announceOrDelegate: anAnnouncementOrClass]!

announceOrDelegate: anAnnouncementOrClass
	
	| announcement |
	announcement _ anAnnouncementOrClass asAnnouncement.
	(self mayAnnounce: announcement class)
		ifFalse: [self errorBadAnnouncementClass: announcement class].
	self subscriptionRegistryOrNil
		ifNotNil:
			[:registry | (registry tryDeliver: announcement from: self) ifTrue: [^announcement]].
	self delegate: announcement.
	^announcement!

parentComponent
	" Never send stuff directly to the parent!! Only used for passing announcements "
	
	^nil! !


!WABrush methodsFor: 'accessing' stamp: ' 9/2/08 12:40'!

asyncUpdater
	
	^parent notNil
		ifTrue: [parent asyncUpdater]
		ifFalse: [nil]! !


!WARenderCanvas methodsFor: 'accessing' stamp: ' 9/2/08 12:40'!

asyncRenderWith: aBlock updatedBrush: updatedBrush
	
	| updater syncBrush |
	updater _ self asyncUpdaterClass
		id: updatedBrush id
		renderWith: [:update :updateCanvas | aBlock cull: updateCanvas].
	syncBrush _ self brush: (AsyncUpdatedArea updater: updater).
	^syncBrush with: aBlock!

asyncRenderWith: aBlock
	
	^self asyncRenderWith: aBlock updatedBrush: parentBrush!

useAsyncCallbacks
	
	^true!

asyncUpdaterClass
	
	^MootoolsAsyncUpdater! !


!SubscriptionRegistry methodsFor: 'privileged' stamp: ' 9/2/08 12:40'!

tryDeliver: announcement from: anObject
	
	| subscribed |
	subscribed _ false.
	classesAndSubscriptions
		keysAndValuesDo:
			[:class :subscriptions | 
			(announcement isKindOf: class)
				ifTrue:
					[subscriptions
						do:
							[:eachSubscription | 
							subscribed _ true.
							eachSubscription process: announcement from: anObject]]].
	^subscribed! !


!WATagBrush methodsFor: 'accessing' stamp: ' 9/2/08 12:40'!

asyncRenderWith: aBlock
	
	self id isNil
		ifTrue: [self error: 'Brush has no ID, async callbacks not possible'].
	^self with: [canvas asyncRenderWith: aBlock updatedBrush: self]!

asyncCallback: callbackBlock
	
	| updater |
	(canvas useAsyncCallbacks and: [(updater _ self asyncUpdater) notNil])
		ifTrue:
			[self onClick: (updater onEventHandlerFor: canvas callback: callbackBlock)]
		ifFalse: [self callback: callbackBlock]! !



ExampleRootComponent initialize!
